<template>
  <div>
    <Header/>
    <main>
      <div class="container mb-5" style="margin-top: 100px;">          
        <div class="row d-flex justify-content-center">
            <div class="col-md-8 ">
                <div class="card" style="background-color:#bdc7c9;">
                    <div class="card-header">CREATE NEW BLOG</div>
                    <div class="card-body">
                        <form @submit.prevent="submitForm">
                            <div class="form-group">
                                <label for="title" class="d-flex justify-content-start">
                                    Title
                                </label>
                                <input type="title" v-model="form.title" class="form-control mb-4" name="title"
                                       :disabled=" buttonStatus == 'upload' ">
                            </div>
                            <div class="form-group">
                                <label for="description" class="d-flex justify-content-start">
                                    Description
                                </label>
                                <textarea class="form-control mb-4" v-model="form.description" name="description" rows="5"
                                          :disabled=" buttonStatus == 'upload' ">
                                </textarea>
                            </div> 
                            <div class="d-flex justify-content-center"
                                 v-if="buttonStatus == 'submit'">                                              
                                <button type="submit" 
                                        class="btn btn-success py-2 px-5 d-flex align-items-center"
                                        ref="createBlog">
                                    CREATE
                                    <!-- <Loading v-if="loading"/> -->
                                </button>   
                            </div>
                           <div class="mt-2" v-else-if="buttonStatus == 'update' ">
                               <input @click="updateBlog(idEditBlog)" type="text" value="Update" 
                                       class="btn btn-success py-2 px-2 mr-3 ">
                               <input @click="clearForm()" type="text" value="Cancel" class="btn btn-info py-2 px-2 ">
                           </div>
                           <div v-else-if="buttonStatus == 'upload' ">
                                <div class="form-group">
                                    <label for="photo" class="d-flex justify-content-start">
                                        Photo
                                    </label>
                                    <input class="form-control-file" type="file" name="photo" ref="photo" id="img">
                                </div>
                                <div class="row">
                                    <div class="col-6">
                                        <div class="row d-flex justify-content-center">
                                            <div class="col-2 mr-4">
                                                <input type="button" value="Upload" @click="submitPhoto(idUploadBlog)" 
                                                class="btn btn-success p-2">
                                            </div>
                                            <div class="col-2" v-if="loading">
                                                <Loading/>
                                            </div>
                                        </div>                                        
                                    </div>
                                    <div class="col-6 d-flex justify-content-start">
                                        <input type="button" value="Cancel"  @click="clearForm()" 
                                                class="btn btn-warning p-2">  
                                    </div>
                                    
                                </div>                                                              
                            </div>
                        </form>                     
                    </div>
                </div>
            </div>           
        </div>  
      </div>
      <div class="container"> 
           <div class="row mt-5">
            <div class="col">
                <table class="table table-hover table-bordered">
                    <thead class="bg-dark text-white">
                        <tr>
                            <th scope="col" style="width: 5%;">No.</th>
                            <th scope="col" style="width: 20%;">Title</th>
                            <th scope="col">Description</th>
                            <th scope="col" style="width: 25%;">Photo</th>
                            <th scope="col" style="width: 20%;">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="(blog, index) in blogs" :key="blog.id">
                            <th scope="row">{{ index + 1 }}</th>
                            <td class="text-left">{{ blog.title }}</td>
                            <td class="text-left">{{ blog.description.substring(0,30) }} ...</td>
                            <td>
                                <img :src="blog.photo ? apiDomain + blog.photo : 'https://randomuser.me/api/portraits/men/81.jpg'" class="card-img-top rounded-lg" alt="photo" style="height:100px; width:100px;" >
                            </td>
                            <td class="d-flex justify-content-center">
                                <button class="btn btn-primary p-2 mr-3" @click="editBlog(blog)">Edit</button>
                                <button class="btn btn-warning p-2 mr-3" @click="removeBlog(blog.id)">Delete</button>
                                <button class="btn btn-success p-2" @click="uploadPhoto(blog)">Upload Photo</button>
                            </td>
                        </tr>                      
                    </tbody>
                </table>
            </div>
        </div> 
      </div>
    </main>
    <Footer/>
  </div>
</template>

<script>
import Header from '@/components/Header.vue'
import Footer from '@/components/Footer.vue'
import Loading from '@/components/Loading.vue'
import axios from 'axios'
import swal from 'sweetalert';
import { mapGetters } from 'vuex'

export default {
  name: 'Store',
  data () {
    return {
        form: {
            title: '',
            description: '',
        },
        loading:false,
        apiDomain: 'https://demo-api-vue.sanbercloud.com',
        blogs: [],
        buttonStatus: 'submit',
        idEditBlog : null,
        idUploadBlog : null,
    }
 },

components: {
Header,
Footer,
Loading,
},

computed: {
        ...mapGetters({
            authCheck:'auth/check',
            user:'auth/user',
            token:'auth/token',
        })
    },

  methods: {
       async submitForm() {
            this.loading = true
            let formData = new FormData()
            formData.append('title', this.form.title)
            formData.append('description', this.form.description)

            let config = {
                method: 'post',
                url: 'https://demo-api-vue.sanbercloud.com/api/v2/blog',               
                data: formData,
                headers: {
                        'Authorization' : 'Bearer ' + this.token,
                },
            }

           await axios(config)
            .then((response) => {
                     this.form.title = ''
                    this.form.description = ''
                    this.loading = false
                    this.getBlogs()
                    console.log(response)
                    swal({
                        title: response.data.message + "  Add New Blog",
                        button: "Close",
                        timer: 2000,
                    });
                })
            .catch((error) => {
                    console.log(error);
                });        
        },

        async getBlogs() {
            const config = {
                method: 'get',
                url : this.apiDomain + '/api/v2/blog/random/30'
            }

            await axios(config)      
                .then((response) => {
                    let { blogs } = response.data;
                    this.blogs = blogs;
                    // console.log(response.data);
                })            
                .catch((error) => {
                    console.log(error);
                })
        },

        editBlog: function (blog) {
            console.log(blog)
            this.form.title = blog.title
            this.form.description = blog.description
            this.buttonStatus = 'update'
            this.idEditBlog = blog.id
            console.log(blog.id)
        },

        async updateBlog(id) {      
            let formData = new FormData()
            formData.append('title', this.form.title)
            formData.append('description', this.form.description)

            let config = {
                method: 'post',
                url: `https://demo-api-vue.sanbercloud.com/api/v2/blog/${id}`,
                params: { _method: "PUT"},
                data: formData,
                headers: {
                        'Authorization' : 'Bearer ' + this.token,
                },
            }

           await axios(config)
            .then((response) => {
                    this.clearForm()
                    this.getBlogs()                   
                    console.log(response)
                    swal({
                        title: response.data.message + "  Updated Blog",
                        button: "Close",
                        timer: 2000,
                    });
                })
            .catch((error) => {
                    console.log(error);
                });
            
        },

        async removeBlog(id) {
            // console.log(id)
            let confirm = window.confirm('Apakah anda yakin menghapus blog ??');
            if (confirm == true) {
                const config = {
                    method: 'post',
                    url: `https://demo-api-vue.sanbercloud.com/api/v2/blog/${id}`,
                    params: { _method: "DELETE"},
                    headers: {
                        'Authorization' : 'Bearer ' + this.token,
                    },
                }

                await axios(config)
                    .then((response) => {
                        this.getBlogs()
                        swal({
                            title: response.data.message + "  Deleted Blog",
                            button: "Close",
                            timer: 2000,
                            });
                        // console.log(response.data.message)
                    })
                    .catch((error) => {
                            console.log(error);
                    });
            }        
        },

        uploadPhoto: function(blog) {
            // console.log(blog)
            this.form.title= blog.title
            this.form.description= blog.description
            this.buttonStatus = 'upload'
            this.idUploadBlog = blog.id
            // console.log(this.idUploadBlog)
        },

        async submitPhoto(id) {
            this.loading = true
            console.log(id);
            if (document.getElementById("img").files.length == 0 ){
                this.loading = false
                swal({
                    title: "Photo Tidak Boleh Kosong !!!!",
                    button: "Close",
                    timer: 2000,
                });
            } else {                                  
            let file = this.$refs.photo.files[0]                
            let formData = new FormData()
                formData.append('photo', file)
                let config = {
                    method: 'post',
                    url: `https://demo-api-vue.sanbercloud.com/api/v2/blog/${id}/upload-photo`,
                    data: formData,
                    headers: {
                        'Authorization' : 'Bearer ' + this.token,
                    },
                }

                await axios(config)
                    .then((response) => {
                            this.clearForm()                                
                            this.getBlogs()
                            this.loading = false
                            swal({
                                title: response.data.message + " Uploaded Photo",
                                button: "Close",
                                timer: 2000,
                            });
                        })
                    .catch((error) => {
                        this.loading = false
                            console.log(error);
                        });
            } 
        }, 

        clearForm: function() {
            this.form.title = ''
            this.form.description = ''
            this.buttonStatus = 'submit'
            this.idEditBlog = null
            this.idUploadBlog = null
        },
  },

  mounted() {
    // this.submitForm();
    this.getBlogs()
    document.title = 'Create New Blog'
  },
}
</script>

<style scoped>
    .card {
        font-size: 16px;
    }
    .card-header {
        color : #2b4f60;
        font-weight: bold;
    }

    .card label {
        font-size: 14px;
        color : #2b4f60;
        font-weight: bold;
    }

    button {
        font-size: 14px;
        font-weight: bold;
    }

    input, textarea {
        font-size: 14px;
    }

    table thead {
        font-size: 14px;
    }

    table tbody {
        font-size: 12px;
    }

    button {
        font-size: 12px;
    }
</style>